Subject: Re: bug#20432: GDK_SCALE=2 GDK_DPI_SCALE=0.5 destroys GTK+ 3 scroll bar

From: Jan Djärv <[email-masked]>
Date: Thu, 14 May 2015 15:13:03 +0200

Den 2015-05-14 14:46, Felix E. Klee skrev:
> On Thu, May 14, 2015 at 1:33 PM, Jan Djärv <[email-masked]> wrote:
>>> That is what `GDK_DPI_SCALE` is for. Example:
>>>
>>>       export GDK_SCALE=2
>>>       export GDK_DPI_SCALE=0.5
>>
>> That does not help. For WM hints, Gtk+ uses GDK_SCALE.
>
> OK. BTW on the system I’ve set up I position and resize windows with the
> WM (FVWM), and there are no issues with `GDK_SCALE`. If I specify that a
> window should be sized 2000 × 1000 px, then it’s set to that size.
> `GDK_SCALE` only affects the contents of the window.

That is true, and part of why this is a half-baked solution.
xrandr --scale works fine for me, no need to fiddle with per application 
settings.  Also, it works fine to plug in a non-hidpi monitor and move apps 
from one monitor to another.  GDK_SCALE absolutely breaks that.

>
>> An alternative would be for Emacs to multply font sizes with
>> GDK_SCALE.
>
> Why bother? Don’t fonts get rendered via the GTK+ API?

Gtk+ is only used for the tool bar, menus and scroll bar (more or less).
Gtk+ is not a requirement for Emacs.
Anyway, its a lot of work.  A lot of Emacs internals needs to know the font 
size and the scaling needs to be applied in many places.

	Jan D.